/* 
  WALL.C - Written by The Last Viking,paal@ekran.no, 5.10.96
  using ncurses....

  compile with: gcc -O -lncurses wall.c -o wall 
*/

#include <ncurses.h>

char grid[26][81];
char ch;

int sc=0,life,cnt,chk,x,y;
int xit,xite,ixit;  /* loop control: ixit=intro,xit=main game,xite=main wrap */
int ballx,bally;
int padx;

float ballxd,ballyd;
float ballxf,ballyf;

struct _win_st wp;

void initbpad(void) {
 padx=30;
 ballx=23;bally=12; ballxf=23;ballyf=12;
 ballxd=0.5;ballyd=0.75;
}

void intro(void) {

 ixit=0;
 clear();
 mvprintw( 5,9,"T XXXX      XXXX  XXXXXXXXXXXX  XXXX           XXXX");
 mvprintw( 6,9,"E XXX        XXX XXXXXXXXXXXXXX XXX            XXX");
 mvprintw( 7,9,"R XX          XX XXXX      XXXX XX             XX");
 mvprintw( 8,9,"M XX          XX XXX        XXX XX             XX");
 mvprintw( 9,9,"I XX    XX    XX XXXXXXXXXXXXXX XX             XX");
 mvprintw(10,9,"N XXX  XXXX  XXX XX          XX XXX         XX XXX         XX");
 mvprintw(11,9,"A XXXXXXXXXXXXXX XXX        XXX XXXX      XXXX XXXX      XXXX");
 mvprintw(12,9,"L  XXXXXXXXXXXX  XXXXX    XXXXX XXXXXXXXXXXXXX XXXXXXXXXXXXXX");
 mvprintw(14,25,"Written by The Last Viking in 1996");
 mvprintw(16,25,"use 'z' and 'x' to control the pad"); 
 mvprintw(17,22,"'q' to quit game and 'e' to end program"); 
 mvprintw(20,33,"press 's' to start"); 
 mvprintw(24,34,"%s%d","last score: ",sc*10); 
 wrefresh(&wp);
 while (ixit==0) {
  ch=(char)getch();
  if (ch=='s') {ixit=1; xit=0; xite=0;}
  if (ch=='e') {ixit=1; xit=1; xite=1;}
 }
 clear();
}

void initwall(void) { /* initialize wall */
 for (x=20;x<=60;x++) /* create wall area */
  for (y=1;y<26;y++) {
   grid[y][x]=' ';
   if ((y>0) && (y<4)) grid[y][x]=ACS_BULLET;
   if ((y>4) && (y<8)) grid[y][x]=ACS_BULLET;
   if ((y>8) && (y<12)) grid[y][x]=ACS_BULLET;
   mvprintw(y,x,"%c",grid[y][x]);
 }
 for (y=0;y<24;y++) {
  mvprintw(y,19,"|");
  mvprintw(y,61,"|");
 }
 mvprintw(10,67,"terminal wall");
 mvprintw(12,72,"coded by");
 mvprintw(13,65,"the last viking");

}

void moveball(void) {
 mvprintw(bally,ballx," ");
 ballyf=ballyf+ballyd;
 ballxf=ballxf+ballxd;
 ballx=(int)ballxf;
 bally=(int)ballyf;
 
 if (grid[bally][ballx]!=' ') {
  grid[bally][ballx]=' ';
  if (12-bally>0) sc=sc+(12-bally);
  ballyd=-ballyd;
 }

 if ((ballx>=60) || (ballx<=20)) ballxd=-ballxd;
 if (ballx>60) {ballxf=60;ballx=60;}
 if (ballx<20) {ballxf=20;ballx=20;}
 if (bally<1)  {ballyd=-ballyd; ballyf=1;}
 if (bally>23) { 
   life--; 
   if (life<0) xit=1; 
   mvprintw(23,padx,"     ");
   initbpad(); 
 }
 if (bally==23) {       /* check if ball hit the bad, and alter directions */
  if ((ballx>padx-2) && (ballx<padx+6)) ballyd=-ballyd;
 
  if (ballx==padx-1) ballxd=ballxd-0.5;
  if (ballx==padx)   ballxd=ballxd-0.3;
  if (ballx==padx+1) ballxd=ballxd-0.2;
  if (ballx==padx+2) ballxd=ballxd;
  if (ballx==padx+3) ballxd=ballxd+0.2;
  if (ballx==padx+4) ballxd=ballxd+0.3;
  if (ballx==padx+5) ballxd=ballxd+0.5;
 }
 if (ballxd>1.5) ballxd=1.5;
 if (ballxd<-1.5) ballxd=-1.5;
 
 mvprintw(bally,ballx,"O");
}

void checkfine(void) {
 chk=0;
 for (x=20;x<=60;x++)       /* check if all the bricks has been knocked down */
  for (y=1;y<12;y++)
   if (grid[y][x]!=' ') chk=1;
 if (chk!=1) {initwall(); initbpad();}                     /* print new wall */
}

void writelinezero(void) {         /* write the uppermost line on the screen */
 mvprintw(10,0,"%s","score: ");
 mvprintw(11,5,"%d",sc*10);
 mvprintw(13,0,"%s","lives: ");
 if (life==3) mvprintw(14,5,"OOO");
 if (life==2) mvprintw(14,5,"OO ");
 if (life==1) mvprintw(14,5,"O  ");
 if (life==0) mvprintw(14,5,"   ");
}

void game_keys(void) {                      /* function for key control, etc */
 ch=(char)getch();
 if (ch=='q') xit=1;
 if (ch=='e') {xite=1; xit=1;}
 if ((ch=='z') && (padx>20)) {padx=padx-2; mvprintw(23,padx+2,"     ");}
 if ((ch=='x') && (padx<55)){padx=padx+2; mvprintw(23,padx-2,"     ");} 
 mvprintw(23,padx,"_____");
}

void main(void) {

 wp=*initscr(); /* initialize curses */
 cbreak();
 noecho();
 nonl();
 intrflush(stdscr, FALSE);
 keypad(stdscr, TRUE);
 nodelay(stdscr,TRUE);
 curs_set(0);

 do {
  intro();
  sc=0; life=3;
  initwall();
  initbpad();

  while (xit==0) {
    wrefresh(&wp);
    writelinezero();
    moveball();
    checkfine(); 
    game_keys();
    timeout(100); 
  }
 } while (xite==0);
 clear();
 printw("bye..");
 wrefresh(&wp);
 endwin();
}

